<?php

// factorize out PDF document JS control function
if (is_admin()) {


  add_action('admin_enqueue_scripts', function() {
      wp_enqueue_script('winddoc_genera_fattura', plugins_url("WD_js.js", __FILE__), array('jquery'));
  });

  add_action('wp_ajax_invoice_admin_command', function() {
    if(isset($_POST["args"]) && isset($_POST["args"]["type"]) && $_POST["args"]["type"]=="fatture"){

      check_ajax_referer("winddoc_genera_documento".$_POST["args"]["id"]."fatture", 'security');

      $WD_Helper= new WD_Helper();
      $ret = $WD_Helper->creaFattura($_POST["args"]["id"]);
      wp_send_json($ret);
    }
    if(isset($_POST["args"]) && isset($_POST["args"]["type"]) && $_POST["args"]["type"]=="ordini"){

      check_ajax_referer("winddoc_genera_documento".$_POST["args"]["id"]."ordini", 'security');

      $WD_Helper= new WD_Helper();
      $ret = $WD_Helper->creaOrdine($_POST["args"]["id"]);
      wp_send_json($ret);
    }
  });


  add_action('admin_head', 'my_custom_css');

  function my_custom_css() {
    echo '<style>
    .loading-overlay {
      display: table;
      opacity: 0.7;
    }

    .loading-overlay-content {
      text-transform: uppercase;
      letter-spacing: 0.4em;
      font-size: 1.15em;
      font-weight: bold;
      text-align: center;
      display: table-cell;
      vertical-align: middle;
    }

    .loading-overlay.loading-theme-light {
      background-color: #fff;
      color: #000;
    }

    .loading-overlay.loading-theme-dark {
      background-color: #000;
      color: #fff;
    }
        </style>';
  }
}
add_action('woocommerce_my_account_my_orders_column_order-actions', function($order) {
  $actions = wc_get_account_orders_actions( $order );

	if ( ! empty( $actions ) ) {
		foreach ( $actions as $key => $action ) {
			echo '<a href="' . esc_url( $action['url'] ) . '" class="woocommerce-button button ' . sanitize_html_class( $key ) . '">' . esc_html( $action['name'] ) . '</a>';
		}
	}

  $WD_Helper= new WD_Helper();
  $dt = $WD_Helper->dettaglioOrdine($order->get_id());

  if(get_option('WD_WINDDOC_ORDINI_ENABLE')!=0){
    if(isset($dt[0]) && isset($dt[0]->url_ordine_winddoc) && $dt[0]->url_ordine_winddoc!=""){
      echo "<a target='_blank' style='text-decoration:none;' class='woocommerce-button button' href='".$dt[0]->url_ordine_winddoc."'>Visualizza Ordine</a>";
    }
  }

  if(get_option('WD_WINDDOC_FATTURE_ENABLE')!=0){
    if(isset($dt[0]) && isset($dt[0]->url_invoice_winddoc) && $dt[0]->url_invoice_winddoc!=""){
      echo "<a target='_blank' style='text-decoration:none;' class='woocommerce-button button'  href='".$dt[0]->url_invoice_winddoc."'>Visualizza Fattua</a>";
    }
  }

});

add_filter( 'woocommerce_admin_billing_fields',  function($billing_fields) {

      global $pagenow;
      $post_type = "";
      if(isset($_GET["post"]) && $_GET["post"]!=""){
        $post_type = get_post_type($_GET["post"]);
      }
      if(isset($_GET["post_type"]) && $_GET["post_type"]!=""){
        $post_type = $_GET['post_type'];
      }
      if( $post_type === 'shop_order' ){

        if(get_option('WD_WINDDOC_CODICE_FISCALE')!=0){
          $billing_fields['billing_codice_fiscale'] = array(
              'type'       => 'text',
              'placeholder' => 'Codice fiscale',
              'label'      => 'Codice Fiscale', //
              'required'   => (get_option('WD_WINDDOC_CODICE_FISCALE')==2 ? true : false),
              'priority'   => 120,
              'clear'      => true
           );
         }

         if(get_option('WD_WINDDOC_PARTITA_IVA')!=0){
           $billing_fields['billing_partita_iva'] = array(
              'type'       => 'text',
              'placeholder' => 'Partita IVA',
              'label'      => 'Partita IVA / VAT', //
              'required'   => (get_option('WD_WINDDOC_PARTITA_IVA')==2 ? true : false),
              'priority'   => 120,
              'clear'      => true,
           );
         }

          if(get_option('WD_WINDDOC_EMAIL_PEC_CODICE_DESTINATARIO')!=0){
             $billing_fields['billing_codice_destinatario'] = array(
                 'type' => 'text',
                 'placeholder' => 'Codice destinatario',
                 'label' => 'Codice destinatario',
                 'priority' => 120,
                 'clear' => true
             );

             $billing_fields['billing_pec'] = array(
                 'type' => 'email',
                 'placeholder' => 'E-mail PEC',
                 'label' => 'E-mail PEC',
                 'validate' => array('email'),
                 'priority' => 120,
                 'clear' => true
             );
           }

      }
      return $billing_fields;
}, 10, 1 );


add_action('woocommerce_checkout_fields', function($fields) {

  if(get_option('WD_WINDDOC_CODICE_FISCALE')!=0){
    $fields['billing']['billing_codice_fiscale'] = array(
        'type'       => 'text',
        'placeholder' => 'Codice fiscale',
        'label'      => 'Codice Fiscale', // edited label Davide Iandoli 24.01.2019
        'required'   => (get_option('WD_WINDDOC_CODICE_FISCALE')==2 ? true : false),
        'priority'   => 120,
        'clear'      => true
     );
   }

   if(get_option('WD_WINDDOC_PARTITA_IVA')!=0){
     $fields['billing']['billing_partita_iva'] = array(
        'type'       => 'text',
        'placeholder' => 'Partita IVA',
        'label'      => 'Partita IVA / VA', // edited label Davide Iandoli 24.01.2019
        'required'   => (get_option('WD_WINDDOC_PARTITA_IVA')==2 ? true : false),
        'priority'   => 120,
        'clear'      => true,
     );
   }

    if(get_option('WD_WINDDOC_EMAIL_PEC_CODICE_DESTINATARIO')!=0){
       $fields['billing']['billing_codice_destinatario'] = array(
           'type' => 'text',
           'placeholder' => 'Codice destinatario',
           'label' => 'Codice destinatario',
           'priority' => 120,
           'clear' => true
       );

       $fields['billing']['billing_pec'] = array(
           'type' => 'email',
           'placeholder' => 'E-mail PEC',
           'label' => 'E-mail PEC',
           'validate' => array('email'),
           'priority' => 120,
           'clear' => true
       );
     }

    return $fields;

});


add_action( 'woocommerce_order_status_changed', function($order_id){
  //if (is_admin()) {
    $order = new WC_Order( $order_id );

    if(get_option('WD_WINDDOC_FATTURE_ENABLE')==1){
      if(get_option('WD_WINDDOC_FATTURE_SINCRONIZZA_FATTURE')==1){
        if($order->status=="processing" || $order->status=="completed"){
          $payment_method = $order->get_payment_method();
          if($payment_method=="cod" || $payment_method=="ppec_paypal"){
            $WD_Helper= new WD_Helper();
            $WD_Helper->creaFattura($order_id);
          }
        }
      }
    }

    if(get_option('WD_WINDDOC_ORDINI_ENABLE')==1){
      if(get_option('WD_WINDDOC_ORDINI_SINCRONIZZA_ORDINI')==1){
        if($order->status=="processing" || $order->status=="completed"){
          $WD_Helper= new WD_Helper();
          $WD_Helper->creaOrdine($order_id,true);
        }
      }
    }
//  }
});
add_action( 'woocommerce_thankyou', function($order_id){


  if (!is_admin()) {
    if(get_option('WD_WINDDOC_ORDINI_ENABLE')==1){
      if(get_option('WD_WINDDOC_ORDINI_SINCRONIZZA_ORDINI')==1){
        $WD_Helper= new WD_Helper();
        $WD_Helper->creaOrdine($order_id,true);
      }
    }

    if(get_option('WD_WINDDOC_FATTURE_ENABLE')==1){
      if(get_option('WD_WINDDOC_FATTURE_SINCRONIZZA_FATTURE')==1){
        $order = new WC_Order( $order_id );
        $payment_method = $order->get_payment_method();
        if($payment_method=="cod" || $payment_method=="ppec_paypal"){
          $WD_Helper= new WD_Helper();
          $WD_Helper->creaFattura($order_id,true);
        }
      }
    }
  }else{
    if(get_option('WD_WINDDOC_FATTURE_ENABLE')==1){
      if(get_option('WD_WINDDOC_FATTURE_SINCRONIZZA_FATTURE')==1){
        $order = new WC_Order( $order_id );
        $payment_method = $order->get_payment_method();
        if($payment_method=="cod" || $payment_method=="ppec_paypal"){
          $WD_Helper= new WD_Helper();
          $WD_Helper->creaFattura($order_id);
        }
      }
    }
  }



},  10, 1  );

add_action('woocommerce_admin_order_data_after_order_details', function($order) {
  $WD_Helper= new WD_Helper();
  $dt = $WD_Helper->dettaglioOrdine($order->get_id());
  echo '<p class="form-field form-field-wide"><br><h2>WindDoc</h2><br>';
  if(get_option('WD_WINDDOC_ORDINI_ENABLE')!=0){
    if(isset($dt[0]) && isset($dt[0]->url_ordine_winddoc) && $dt[0]->url_ordine_winddoc!=""){
      echo "<a target='_blank' style='text-decoration:none;' class='order-status status-processing' href='".$dt[0]->url_ordine_winddoc."'>&nbsp;&nbsp;Visualizza Ordine&nbsp;&nbsp;</a>&nbsp;&nbsp;";
    }else{
      echo "<a class='order-status status-on-hold' onclick='winddoc_genera_documento(\"".$order->get_id()."\",\"ordini\",\"".wp_create_nonce("winddoc_genera_documento".$order->get_id()."ordini")."\")'>&nbsp;&nbsp;Genera Ordine&nbsp;&nbsp;</a>&nbsp;&nbsp;";
    }
  }

  if(get_option('WD_WINDDOC_FATTURE_ENABLE')!=0){
    if(isset($dt[0]) && isset($dt[0]->url_invoice_winddoc) && $dt[0]->url_invoice_winddoc!=""){
      echo "<a target='_blank' style='text-decoration:none;' class='order-status status-processing'  href='".$dt[0]->url_invoice_winddoc."'>&nbsp;&nbsp;Visualizza Fattua&nbsp;&nbsp;</a>";
    }else{
      echo "<a class='order-status status-on-hold' onclick='winddoc_genera_documento(\"".$order->get_id()."\",\"fatture\",\"".wp_create_nonce("winddoc_genera_documento".$order->get_id()."fatture")."\")'>&nbsp;&nbsp;Genera Fattura&nbsp;&nbsp;</a>";
    }
  }
  echo '</p>';
}, 10, 1);

add_filter('manage_edit-shop_order_columns', function($columns) {
    $col = is_array($columns) ? $columns : array();

    if(get_option('WD_WINDDOC_ORDINI_ENABLE')!=0){
      $col['winddoc-order'] = 'WindDoc Ordini';
    }
    if(get_option('WD_WINDDOC_FATTURE_ENABLE')!=0){
      $col['winddoc-invoice'] = 'WindDoc Fatture';
    }
    return $col;
});


add_action('manage_shop_order_posts_custom_column', function($column) {

    if ($column == 'winddoc-order') {
        global $post;
        $order = new \WC_Order($post->ID);
        $WD_Helper= new WD_Helper();
        $dt = $WD_Helper->dettaglioOrdine($order->get_id());
        if(isset($dt[0]) && isset($dt[0]->url_ordine_winddoc) && $dt[0]->url_ordine_winddoc!=""){
          echo "<a target='_blank' class='order-status status-processing' href='".$dt[0]->url_ordine_winddoc."'>&nbsp;&nbsp;Visualizza Ordine&nbsp;&nbsp;</a>";
        }else{
          echo "<a class='order-status status-on-hold' onclick='winddoc_genera_documento(\"".$order->get_id()."\",\"ordini\",\"".wp_create_nonce("winddoc_genera_documento".$order->get_id()."ordini")."\")'>&nbsp;&nbsp;Genera Ordine&nbsp;&nbsp;</a>";
        }
    }
    if ($column == 'winddoc-invoice') {
        global $post;
        $order = new \WC_Order($post->ID);
        $WD_Helper= new WD_Helper();
        $dt = $WD_Helper->dettaglioOrdine($order->get_id());
        if(isset($dt[0]) && isset($dt[0]->url_invoice_winddoc) && $dt[0]->url_invoice_winddoc!=""){
          echo "<a target='_blank' class='order-status status-processing'  href='".$dt[0]->url_invoice_winddoc."'>&nbsp;&nbsp;Visualizza Fattua&nbsp;&nbsp;</a>";
        }else{
          echo "<a class='order-status status-on-hold' onclick='winddoc_genera_documento(\"".$order->get_id()."\",\"fatture\",\"".wp_create_nonce("winddoc_genera_documento".$order->get_id()."fatture")."\")'>&nbsp;&nbsp;Genera Fattura&nbsp;&nbsp;</a>";
        }
    }

}, 2);
