<?php

class WD_Helper{

    public $root_login = 'https://app.winddoc.com/oauth-login.php?token_app=9ecb6d8e62357d14b1cc7a5450a62e9b557982f753d5f38f1fd02024613bdd91';
    public $root = 'https://app.winddoc.com';


    public function creaOrdine($order,$force_payment=false){
      $dt = $this->dettaglioOrdine($order);

      if(!isset($dt[0]) || !isset($dt[0]->url_ordine_winddoc) || !$dt[0]->url_ordine_winddoc!=""){
        $data = $this->getDataFromOrder($order,"ordini",$force_payment);

        $WindDocTalker = new WindDocTalker();

        $data = $WindDocTalker->sendDocument($data,$data["document_type"]);

        if(!isset($data["id"])){
          $ret["success"] = false;
          $ret["message"] = 'Non è stato possibile creare l\'ordine in WindDoc';

        }else{
          $this->aggiungiWinDocToOrder($order,$data["id"],$data["url"]);
          $ret["success"] = true;
          $ret["message"] = 'Ordine Creato correttamente in WindDoc.';
        }
      }else{
        $ret["success"] = false;
        $ret["message"] = 'Ordine già creato in WindDoc';
      }
      return $ret;
    }

    public function creaFattura($order,$force_payment=false){
      $dt = $this->dettaglioOrdine($order);
      if(!isset($dt[0]) || !isset($dt[0]->url_invoice_winddoc) || !$dt[0]->url_invoice_winddoc!=""){
        $data = $this->getDataFromOrder($order,"fatture",$force_payment);

        $det = $this->dettaglioOrdine($order);


        if(isset($det["id_ordine_winddoc"]) && $det["id_ordine_winddoc"]!=""){
          $data["relation"][0]["parent_type"] = "ordini";
          $data["relation"][0]["parent_id"] = $det["id_ordine_winddoc"];
        }

        //verifico se devo inviare l'email
        if(get_option('WD_WINDDOC_FATTURE_SEND_EMAIL')==1){
          $data["send_email"] = true;
        }

        $WindDocTalker = new WindDocTalker();

        $data = $WindDocTalker->sendDocument($data,$data["document_type"]);


        $ret = array();
        if(!isset($data["id"])){
          $ret["success"] = false;
          $ret["message"] = 'Non è stato possibile creare la fattura in WindDoc';
        }else{
          $this->aggiungiWinDocToInvoice($order,$data["id"],$data["url"]);
          $ret["success"] = true;
          $ret["message"] = 'Fattura Creata correttamente in WindDoc.';
        }
      }else{
        $ret["success"] = false;
        $ret["message"] = 'Fattura già creata in WindDoc';
      }
      return $ret;
    }


    public function aggiungiWinDocToOrder($sales_flat_order_id,$id_ordine_winddoc,$url_ordine_winddoc){
      if(!$this->dettaglioOrdine($sales_flat_order_id)){
          $this->addNewOrder($sales_flat_order_id);
      }


      global $wpdb;
      $table_name = $wpdb->prefix.'winddoc_sinc_order';
      $wpdb->update($table_name,array("url_ordine_winddoc"=>$url_ordine_winddoc,
                                      "id_ordine_winddoc"=>$id_ordine_winddoc,
                                      "data_modifica"=>current_time( 'mysql' )),
                                array("sales_flat_order_id"=>$sales_flat_order_id));


    }

    public function aggiungiWinDocToInvoice($sales_flat_order_id,$id_invoice_winddoc,$url_invoice_winddoc){
      if(!$this->dettaglioOrdine($sales_flat_order_id)){
          $this->addNewOrder($sales_flat_order_id);
      }


      global $wpdb;
      $table_name = $wpdb->prefix.'winddoc_sinc_order';
      $wpdb->update($table_name,array("url_invoice_winddoc"=>$url_invoice_winddoc,
                                      "id_invoice_winddoc"=>$id_invoice_winddoc,
                                      "data_modifica"=>current_time( 'mysql' )),
                                array("sales_flat_order_id"=>$sales_flat_order_id));

    }

    public function getIdCustomerWinddoc($id_customer){
      $det = $this->dettaglioSincroCustomer($id_customer);
      if(isset($det["id_customer_winddoc"])){
        return $det["id_customer_winddoc"];
      }
      return false;
    }

    public function dettaglioOrdine($sales_flat_order_id = ""){
      global $wpdb;
      $table_name = $wpdb->prefix.'winddoc_sinc_order';
      $det = $wpdb->get_results("SELECT * FROM `" . $table_name . "` WHERE `sales_flat_order_id` = '" .$sales_flat_order_id . "'");

      if(isset($det)){
        return $det;
      }
      return false;
    }


    public function dettaglioSincroCustomer($id_customer){
      global $wpdb;
      $table_name = $wpdb->prefix.'winddoc_sinc_order';
      $det = $wpdb->get_results("SELECT * FROM `" . $table_name."` WHERE `customer_id` = '" .$id_customer . "'");
      if(isset($det)){
        return $det;
      }
      return false;

    }

    public function aggiungiSincroCustomer($customer_id,$id_customer_winddoc){

      global $wpdb;
      $table_name = $wpdb->prefix.'winddoc_sinc_customer';
      $wpdb->insert($table_name,array("customer_id"=>$customer_id,
                                      "id_customer_winddoc"=>$id_customer_winddoc,
                                      "data_creazione"=>current_time( 'mysql' ),
                                      "data_modifica"=>current_time( 'mysql' )));

    }

    public function addNewOrder($id){
      global $wpdb;
      $table_name = $wpdb->prefix.'winddoc_sinc_order';
      $wpdb->insert($table_name,array("sales_flat_order_id"=>$id,
                                      "data_creazione"=>current_time( 'mysql' ),
                                      "data_modifica"=>current_time( 'mysql' )));

    }

    public function getDataFromOrder($id_order,$type="",$force_payment=false){




      $order = new \WC_Order($id_order);



      $data = array();
      $data["document_type"] = $type;
      if($type=="fatture"){
        $data["numerazione"] = get_option("WD_WINDDOC_FATTURE_NUMERAZIONE");
      }
      if($type=="ricevute"){
        $data["numerazione"] = get_option("WD_WINDDOC_RICEVUTE_NUMERAZIONE");
      }
      if($type=="ordini"){
        $data["numerazione"] = get_option("WD_WINDDOC_ORDINI_NUMERAZIONE");
      }
      $data["valuta"] = "e994378e-c24b-12e2-cb41-5717c48cdc99"; //Impostiamo di defaut €

      //template_stampa
      if($type=="fatture"){
        $data["template_stampa"] = get_option("WD_WINDDOC_FATTURE_TEMPLATE");
        if($order->get_order_number()!=""){
          $data["dicitura_invoice"] = "Riferimento Ordine #".$order->get_order_number();
        }else{
          $data["dicitura_invoice"] = "Riferimento Ordine #".$id_order;
        }
      }
      if($type=="ordini"){
        $data["template_stampa"] = get_option("WD_WINDDOC_ORDINI_TEMPLATE");
        if($order->get_order_number()!=""){
          $data["dicitura_quote"] = "Riferimento Ordine #".$order->get_order_number();
        }else{
          $data["dicitura_quote"] = "Riferimento Ordine #".$id_order;
        }
      }
      if($type=="ricevute"){
        $data["template_stampa"] = get_option("WD_WINDDOC_RICEVUTE_TEMPLATE");
        if($order->get_order_number()!=""){
          $data["dicitura_invoice"] = "Riferimento Ordine #".$order->get_order_number();
        }else{
          $data["dicitura_invoice"] = "Riferimento Ordine #".$id_order;
        }
      }


      $indirizzo_fatturazione = array();
      $indirizzo_fatturazione["contatto_nome"] = trim($order->data["billing"]["first_name"]);
      $indirizzo_fatturazione["contatto_cognome"] = trim($order->data["billing"]["last_name"]);
      $indirizzo_fatturazione["contatto_codice_fiscale"] = $this->parseMetadata($order,"_billing_codice_fiscale");
      $indirizzo_fatturazione["contatto_partita_iva"] = $this->parseMetadata($order,"_billing_partita_iva");
      $indirizzo_fatturazione["contatto_codice_destinatario"] = $this->parseMetadata($order,"_billing_codice_destinatario");
      $indirizzo_fatturazione["contatto_email_pec"] = $this->parseMetadata($order,"_billing_pec");
      $indirizzo_fatturazione["contatto_ragione_sociale"] = $order->data["billing"]["company"];
      if($indirizzo_fatturazione["contatto_nome"]==""){
        $indirizzo_fatturazione["contatto_nome"] = $order->data["billing"]["company"];
      }
      $indirizzo_fatturazione["contatto_indirizzo_via"] = trim($order->data["billing"]["address_1"]." ".$order->data["billing"]["address_2"]);
      $indirizzo_fatturazione["contatto_indirizzo_citta"] = $order->data["billing"]["city"];
      $indirizzo_fatturazione["contatto_indirizzo_cap"] = $order->data["billing"]["postcode"];
      $indirizzo_fatturazione["contatto_indirizzo_provincia"] = $order->data["billing"]["state"];
      $indirizzo_fatturazione["contatto_indirizzo_nazione"] = $order->data["billing"]["country"];
      $indirizzo_fatturazione["contatto_email"] = $order->data["billing"]["email"];

      if(isset($order->data["billing"]["phone"]) && $order->data["billing"]["phone"]!=""){
        $data["contatto_indirizzo_extra"] = "Telefono : ".$order->data["billing"]["phone"];
      }





      $indirizzo_spedizione = array();
      $indirizzo_spedizione["contatto_nome"] = trim($order->data["shipping"]["first_name"]);
      $indirizzo_spedizione["contatto_cognome"] = trim($order->data["shipping"]["last_name"]);
      $indirizzo_spedizione["contatto_ragione_sociale"] = $order->data["shipping"]["company"];
      if($indirizzo_spedizione["contatto_nome"]==""){
        $indirizzo_spedizione["contatto_nome"] = $order->data["shipping"]["company"];
      }
      $indirizzo_spedizione["contatto_indirizzo_via"] = trim($order->data["shipping"]["address_1"]." ".$order->data["shipping"]["address_2"]);
      $indirizzo_spedizione["contatto_indirizzo_citta"] = $order->data["shipping"]["city"];
      $indirizzo_spedizione["contatto_indirizzo_cap"] = $order->data["shipping"]["postcode"];
      $indirizzo_spedizione["contatto_indirizzo_provincia"] = $order->data["shipping"]["state"];
      $indirizzo_spedizione["contatto_indirizzo_nazione"] = $order->data["shipping"]["country"];




      if($indirizzo_fatturazione["contatto_partita_iva"]=="" && $indirizzo_fatturazione["contatto_codice_fiscale"]!=""){
        //E' un privato
        if($type=="fatture"){
          if(get_option("WD_WINDDOC_RICEVUTE_SINCRONIZZA_RICEVUTE")==1){
            $data["numerazione"] = get_option("WD_WINDDOC_ORDINI_NUMERAZIONE");
            $data["document_type"] = "ricevute";
            $type = "ricevute";
          }
        }
      }

      $data["contatto_nome"] = $indirizzo_fatturazione["contatto_nome"];
      $data["contatto_cognome"] = $indirizzo_fatturazione["contatto_cognome"];
      $data["contatto_codice_fiscale"] = $indirizzo_fatturazione["contatto_codice_fiscale"];
      $data["contatto_ragione_sociale"] = $indirizzo_fatturazione["contatto_ragione_sociale"];
      $data["contatto_indirizzo_citta"] = $indirizzo_fatturazione["contatto_indirizzo_citta"];
      $data["contatto_indirizzo_nazione"] = $indirizzo_fatturazione["contatto_indirizzo_nazione"];
      $data["contatto_indirizzo_cap"] = $indirizzo_fatturazione["contatto_indirizzo_cap"];
      $data["contatto_indirizzo_provincia"] = $indirizzo_fatturazione["contatto_indirizzo_provincia"];
      $data["contatto_indirizzo_via"] = $indirizzo_fatturazione["contatto_indirizzo_via"];
      $data["contatto_partita_iva"] = $indirizzo_fatturazione["contatto_partita_iva"];
      $data["contatto_email"] = $indirizzo_fatturazione["contatto_email"];
      $data["contatto_codice_destinatario"] = $indirizzo_fatturazione["contatto_codice_destinatario"];
      $data["contatto_email_pec"] = $indirizzo_fatturazione["contatto_email_pec"];


      if( $indirizzo_spedizione["contatto_nome"] != $indirizzo_fatturazione["contatto_nome"]  ||
          $indirizzo_spedizione["contatto_ragione_sociale"] != $indirizzo_fatturazione["contatto_ragione_sociale"]  ||
          $indirizzo_spedizione["contatto_indirizzo_via"] != $indirizzo_fatturazione["contatto_indirizzo_via"]  ||
          $indirizzo_spedizione["contatto_indirizzo_citta"] != $indirizzo_fatturazione["contatto_indirizzo_citta"]  ||
          $indirizzo_spedizione["contatto_indirizzo_cap"] != $indirizzo_fatturazione["contatto_indirizzo_cap"]  ||
          $indirizzo_spedizione["contatto_indirizzo_provincia"] != $indirizzo_fatturazione["contatto_indirizzo_provincia"]  ||
          $indirizzo_spedizione["contatto_indirizzo_nazione"] != $indirizzo_fatturazione["contatto_indirizzo_nazione"]
        ){
          $data["cointestatario"][0] = array();
          $data["cointestatario"][0]["nome"] = $indirizzo_spedizione["contatto_nome"];
          $data["cointestatario"][0]["cognome"] = $indirizzo_spedizione["contatto_cognome"];
          $data["cointestatario"][0]["codice_fiscale"] = "";
          $data["cointestatario"][0]["ragione_sociale"] = $indirizzo_spedizione["contatto_ragione_sociale"];
          $data["cointestatario"][0]["indirizzo_citta"] = $indirizzo_spedizione["contatto_indirizzo_citta"];
          $data["cointestatario"][0]["indirizzo_nazione"] = $indirizzo_spedizione["contatto_indirizzo_nazione"];

          $data["cointestatario"][0]["indirizzo_cap"] = $indirizzo_spedizione["contatto_indirizzo_cap"];
          $data["cointestatario"][0]["indirizzo_provincia"] = $indirizzo_spedizione["contatto_indirizzo_provincia"];

          $data["cointestatario"][0]["indirizzo_via"] = $indirizzo_spedizione["contatto_indirizzo_via"];
          $data["cointestatario"][0]["partita_iva"] = "";
          $data["cointestatario"][0]["email"] = "";
          $data["cointestatario"][0]["codice_destinatario"] = "";
          $data["cointestatario"][0]["email_pec"] = "";
      }

      $items = array();
      foreach ($order->get_items('line_item') as $item){
        $items[] = $item;
      }
      foreach ($order->get_items('shipping') as $item){
        $items[] = $item;
      }
      foreach ($order->get_items('fee') as $item){
        $items[] = $item;
      }

      $totale = 0;
      $vatAmount = 0;
      $totalWithoutTax = 0;

      $data["prodotto"] = array();
      $iva_totale = array();

      if($order->get_customer_note()!=""){
        $prodotto["tipo_riga"] = 1; //Tipo riga Descrizione
        $prodotto["nome"] = "Note Cliente";
        $prodotto["note"] = $order->get_customer_note();
        $data["prodotto"][] = $prodotto;
      }


    /*  foreach ($items as $item){
        if($item->get_total() != 0){
          $vat = round(($item->get_total_tax() / $item->get_total()),2)*100;
          $nome_iva = trim(' '.$vat);
          $total_tax = round($item->get_total_tax(),2);
          if(isset($nome_iva)){
            $iva_totale[$nome_iva] = $iva_totale[$nome_iva] + $total_tax;
          }else{
            $iva_totale[$nome_iva] = $total_tax;
          }
        }
      }*/

      foreach ($items as $item){
        $prodotto = array();

        $prodotto["importo_totale"] = round($item->get_total()+$item->get_total_tax(),2);

        if($item->get_type() == 'line_item'){

          $prodotto["tipo_riga"] = 0; //Tipo riga prodotto
          $prodotto["quantita"] = $item->get_quantity();
          $prodotto["prezzo_netto"] = round($item->get_total()/$prodotto["quantita"],2);

          $prodotto["codice"] = $item->get_product()->get_sku();
          $prodotto["nome"] = $item->get_name();
          if($prodotto["codice"]==""){
            //PER EBAY
            $prodotto["codice"] = wc_get_order_item_meta($item->get_id(), "SKU", true);
          }

          $prodotto["unita_misura"] = "pz";
          $prodotto["sconto"] = 0;
          $prodotto["iva_importo"] = round((($item->get_total_tax() / $item->get_total())*100),2);

          $prodotto["iva_name"] = "";

          if($type=="fatture" || $type=="ricevute"){
            if(get_option("WD_WINDDOC_FATTURE_MAGAZZINO")==1){
              $prodotto["scarica_da_magazzino"] = 1;
            }
          }
          if($type=="ordini"){
            if(get_option("WD_WINDDOC_ORDINI_MAGAZZINO")==1){
              $prodotto["scarica_da_magazzino"] = 1;
            }
          }

          //$sconto =  $item->get_subtotal() - $item->get_total()
         }elseif($item->get_type()=='fee' || $item->get_type()=='shipping'){
           $prodotto["quantita"] = 1;
           $prodotto["tipo_riga"] = 2; //Tipo riga servizio
           $prodotto["prezzo_netto"] = $item->get_total();

           $prodotto["codice"] = "";
           $prodotto["nome"] = $item->get_name();
           $prodotto["unita_misura"] = "pz";
           $prodotto["sconto"] = 0;
           $prodotto["iva_importo"] = round((($item->get_total_tax() / $item->get_total())*100),2);
           $prodotto["iva_name"] = "";
       }

       $data["prodotto"][] = $prodotto;
       $totale_calcolo = $totale_calcolo  + $prodotto["importo_totale"];
      }



      $data["scadenza"] = array();
      $data["scadenza"][0]["ammontare"] = $totale_calcolo;
      $data["scadenza"][0]["termini"] = "0"; //Immediato
      $data["scadenza"][0]["scadenza"] = time();

      $payment_method = $order->get_payment_method();

      if($force_payment && $payment_method!="cod" && $payment_method=="ppec_paypal"){
        $data["scadenza"][0]["id_conto"] ="non_saldato";
      }else{
        if($type == 'fatture'){
          $data["scadenza"][0]["id_conto"] = get_option("WD_WINDDOC_FATTURE_PAGAMENTO");
          if($data["scadenza"][0]["id_conto"]!="0"){
            $data["scadenza"][0]["data_saldo"] = time();
          }
        }
        if($type == 'ricevute'){
          $data["scadenza"][0]["id_conto"] = get_option("WD_WINDDOC_RICEVUTE_PAGAMENTO");
          if($data["scadenza"][0]["id_conto"]!="0"){
            $data["scadenza"][0]["data_saldo"] = time();
          }
        }
      }

      return $data;

    }

    public function parseMetadata($order,$name){
      return get_post_meta($order->get_id(), $name, true);
    }


    public function sincroCustomerByOrder($order){
      //Verifico se il cliente è già sincronizzato

      $order = new Order($order['id_order']);
      $indirizzo_fatturazione = new Address($order->id_address_invoice);
      $indirizzo_spedizione = new Address($order->id_address_delivery);

      $ret = $this->dettaglioSincroCustomer($indirizzo_fatturazione->id_customer);



      if(isset($ret["id_customer_winddoc"]) && $ret["id_customer_winddoc"]!=""){
        return $ret["id_customer_winddoc"];
      }else{
        $data = array();
        $data["tipo_contatto"] = 1;//tipo contatto lo impostiamo come cliente
        if($indirizzo_fatturazione->vat_number=="" && $indirizzo_fatturazione->dni!=""){
          $data["nome"] = trim($indirizzo_fatturazione->firstname);
          $data["cognome"] = trim($indirizzo_fatturazione->lastname);
          $data["codice_fiscale"] = $indirizzo_fatturazione->dni;
          $data["ragione_sociale"] = "";
          $data["indirizzo_citta"] = $indirizzo_fatturazione->city;
          $Country = new Country($indirizzo_fatturazione->id_country);
          $data["indirizzo_nazione"] = $Country->iso_code;
          $data["indirizzo_cap"] = $indirizzo_fatturazione->postcode;
          if (!empty($indirizzo_fatturazione->id_state)){
              $state = new State($indirizzo_fatturazione->id_state);
              $data["indirizzo_provincia"] =$state->iso_code;
          }
          $data["indirizzo_via"] = trim($indirizzo_fatturazione->address1." ".$indirizzo_fatturazione->address2);
          $data["partita_iva"] = "";
          $data["email"] = $customer->email;
          $data["codice_destinatario"] = "";
          $data["email_pec"] = "";
        }else{
          $data["nome"] = trim($indirizzo_fatturazione->firstname);
          $data["cognome"] = trim($indirizzo_fatturazione->lastname);
          if($data["nome"]==""){
            $data["nome"] = $indirizzo_fatturazione->company;
          }
          $data["codice_fiscale"] = $indirizzo_fatturazione->dni;
          $data["ragione_sociale"] = $indirizzo_fatturazione->company;
          $data["indirizzo_citta"] = $indirizzo_fatturazione->city;
          $Country = new Country($indirizzo_fatturazione->id_country);
          $data["indirizzo_nazione"] = $Country->iso_code;
          $data["indirizzo_cap"] = $indirizzo_fatturazione->postcode;
          if (!empty($indirizzo_fatturazione->id_state)){
              $state = new State($indirizzo_fatturazione->id_state);
              $data["indirizzo_provincia"] =$state->iso_code;
          }
          $data["indirizzo_via"] = trim($indirizzo_fatturazione->address1." ".$indirizzo_fatturazione->address2);
          $data["partita_iva"] = $indirizzo_fatturazione->vat_number;
          $data["email"] = $customer->email;
          $data["codice_destinatario"] = "";
          $data["email_pec"] = "";
        }
        $data["telefono"] = $indirizzo_fatturazione->phone;



        $WindDocTalker = new WindDocTalker();

        $ret = $WindDocTalker->aggiungiCustomer($data);
        $this->aggiungiSincroCustomer($indirizzo_fatturazione->id_customer,$ret);
        return $ret;
      }

    }

    public function getConti(){
      $WindDocTalker = new WindDocTalker();
      $template = $WindDocTalker->getConti();
      $ret = array();
      $ret["predefinito"] = "Predefinito";

      if(isset($template->lista) && count($template->lista)>0){
        foreach ($template->lista as $value) {
          $nome = "";
          $id_templatestampa = "";

          foreach ($value as $v) {
            if($v->name=="id_conto"){
              $id_templatestampa = $v->value;
            }
            if($v->name=="nome"){
              $nome = $v->value;
            }
          }
          $ret[$id_templatestampa] = $nome;
        }
      }

      return $ret;
    }

    public function getTemplateRicevute(){
      $WindDocTalker = new WindDocTalker();
      $template = $WindDocTalker->getTemplateRicevute();
      $ret = array();
      $ret["predefinito"] = "Predefinito";
      if(isset($template->lista) && count($template->lista)>0){
        foreach ($template->lista as $value) {
          $nome = "";
          $id_templatestampa = "";
          foreach ($value as $v) {
            if($v->name=="id_templatestampa"){
              $id_templatestampa = $v->value;
            }
            if($v->name=="nome"){
              $nome = $v->value;
            }
          }
          $ret[$id_templatestampa] = $nome;
        }
      }
      return $ret;
    }

    public function getTemplateInvoice(){
      $WindDocTalker = new WindDocTalker();
      $template = $WindDocTalker->getTemplateInvoice();
      $ret = array();
      $ret["predefinito"] = "Predefinito";
      if(isset($template->lista) && count($template->lista)>0){
        foreach ($template->lista as $value) {
          $nome = "";
          $id_templatestampa = "";
          foreach ($value as $v) {
            if($v->name=="id_templatestampa"){
              $id_templatestampa = $v->value;
            }
            if($v->name=="nome"){
              $nome = $v->value;
            }
          }
          $ret[$id_templatestampa] = $nome;
        }
      }
      return $ret;
    }

    public function getTemplateQuote(){
      $WindDocTalker = new WindDocTalker();
      $template = $WindDocTalker->getTemplateQuote();
      $ret = array();
      $ret["predefinito"] = "Predefinito";
      if(isset($template->lista) && count($template->lista)>0){
        foreach ($template->lista as $value) {
          $nome = "";
          $id_templatestampa = "";
          foreach ($value as $v) {
            if($v->name=="id_templatestampa"){
              $id_templatestampa = $v->value;
            }
            if($v->name=="nome"){
              $nome = $v->value;
            }
          }
          $ret[$id_templatestampa] = $nome;
        }
      }
      return $ret;
    }



}




class WindDocTalker
{
    private $url;
    private $soapclient;
    private $sessionId;
    private $token_app = "9ecb6d8e62357d14b1cc7a5450a62e9b557982f753d5f38f1fd02024613bdd91";

    function __construct(){

      $this->url = 'https://app.winddoc.com/v1/api.php?wsdl';
      $this->soapclient = new SoapClient(null,
                                         array('location' => $this->url,
                                         'uri'            => $this->url,
                                         'soap_version'   => SOAP_1_1,
                                         'trace'          => 1,
                                         'exceptions'     => 0
                                        ));
    }


  public function sendDocument($data,$tipo){
    if($this->Login()){

      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam($this->paseData($data),  'params'),
      );

      if($tipo=="fatture"){
        $ret = $this->__call("fatture_aggiungi", $args);
        return $ret;
      }
      if($tipo=="ricevute"){
        $ret = $this->__call("ricevute_aggiungi", $args);
        return $ret;
      }
      if($tipo=="ordini"){
        $ret = $this->__call("ordini_aggiungi", $args);
        return $ret;
      }
      $this->Close();
    }
  }

  public function aggiungiCustomer($data){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam($this->paseData($data),  'params'),
      );

      $ret = $this->__call("contatti_aggiungi", $args);

      $this->Close();
      return $ret;


    }
  }

  public function getConti(){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam("1",  'pagina'),
      );
      $ret = $this->__call("settings_conti_lista", $args);
      $this->Close();
      return $ret;
    }
  }


  public function getTemplateRicevute(){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam("1",  'pagina'),
      );
      $ret = $this->__call("ricevute_listaTemplate", $args);
      $this->Close();
      return $ret;
    }
  }


  public function getTemplateQuote(){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam("1",  'pagina'),
      );
      $ret = $this->__call("ordini_listaTemplate", $args);
      $this->Close();
      return $ret;
    }
  }

  public function getTemplateInvoice(){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam("1",  'pagina'),
      );
      $ret = $this->__call("fatture_listaTemplate", $args);
      $this->Close();
      return $ret;
    }
  }


  public function paseData($data){

		$args = array();
    foreach ($data as $key => $value) {
      if(is_array($value)){
        $args[] = new SoapParam($this->paseData($value),  $key);
      }else{
        $args[] = new SoapParam($value,  $key);
      }
    }

		return $args;
	}

	public function Login(){

		$args = array(
		 'token' => get_option('WD_WINDDOC_TOKEN'),
		 'token_app' => $this->token_app
		);

	  $this->sessionId = $this->__call("login", $args);

    if($this->sessionId!=""){
      return true;
    }
    return false;
	}

  public function Close(){

		$args = array(
		 'id_session' => $this->sessionId
		);

	  $this->__call("close", $args);
	}


	public function __call($method, $args){

	   //return call_user_func_array(array($this->soapclient, $method), $args);
     $response = $this->soapclient->__soapCall($method, $args);

     if(is_object($response) && get_class($response)=="SoapFault"){
       return array();
     }
     return $response;

  }


}
